require"json"
require"libcrython_lua"

--
-- Decode object and method strings
--

local _,_,object,method = string.find(
	lighty.env['physical.rel-path'],
	"/methods/([^/]*)/([^/]*)"
)

if not (object and method) then
	return 404
end

--
-- Decode arguments
--

args = lighty.env['uri.query'] or ''
print(args)
args = string.gsub(args, "%%(%x%x)", function (h) return string.char(tonumber(h, 16)) end)
args = json.decode(args)
--for i,v in pairs(args) do args[i],args[tonumber(i)] = nil,v end

--
-- Look up object, method
--

objects = {
	CryoBoard = libcrython_lua.CryoBoard()
}

object = objects[object]
if not object then
	print("No such object")
	return 404
end
method = object[method]
if not method then
	print("No such method")
	return 404
end

local returned

wrapped = function() returned = method(object, unpack(args)) end
ok, trace = xpcall(wrapped, debug.traceback)

if ok then
	lighty.content = { json.encode({ message="ok", returned=returned }) .. "\n" }
else
	lighty.content = { json.encode({error = { trace = trace}}) .. "\n" }
end

lighty.header["Content-Type"] = "text/plain" 
return 200

