<%inherit file="base.inc" />

<h1>Configuration</h1>
<%doc>
<table>
	<thead>
		<caption>Channel Configuration</caption>
		<tr>
			<th>Channel</th><th>Name</th><th>Type</th><th colspan=2>Gain Resistors</th><th>ADC Offset</th><th>Calibration File</th>
		</tr>
		<tr>
			<th /><th /><th /><th>Drive</th><th>Sense</th><th /><th />
		</tr>
	</thead>
	<tbody>
		$cooked_channels[[
			<tr>
				<td>$index</td>
				<td>
					<input type="text"
						id=$sf{'channel_%i_name', $index0}
						value="$cc|get_channel_name{$index0}"
						disabled=true
					/>
				</td>
				<td>
					<select id=$sf{'channel_%i_type', $index0}
						style="width: 100px;"
						value="$cc|get_channel_type{$index0}"
						disabled=true
					>

						<option value="Diode">Diode</option>
						<option value="RTD">RTD</option>
					</select>
					
				</td>
				<td>
					<input type="text" size="10"
						id=$sf{'channel_%i_drive_resistance',index0}
						value="$cc|get_drive_resistance{$index0}"
						disabled=true
					/>
				</td>
				<td>
					<input type="text" size="10"
						id=$sf{'channel_%i_sense_resistance',index0}
						value="$cc|get_sense_resistance{index0}"
						disabled=true
					/>
				</td>
				<td>
					<input type="text"
						id=$sf{'channel_%i_adc_offset',index0}
						value="$cb|get_channel_adc_offset{index0, $crython|RAW}"
						disabled=true
					>
				</td>
				<td>
					<form method="post" enctype="multipart/form-data" action="set_channel_parameters.cgi">
						<input type="file" name="calibration" />
						<input type="hidden" name="object" value="CryoConverter" />
						<input type="hidden" name="channel" value=${c} />
						<input type="hidden" name="redirect" value='configuration' />
						<input type="submit" value="upload" disabled="true" />
					</form>
				</td>
			</tr>
		]]
	</tbody>
</table>

<table>
	<thead>
		<caption>Heater Configuration</caption>
		<tr>
			<th>Channel</th><th>Name</th><th>Resistance</th><th>Actions</th>
		</tr>
	</thead>
	<tbody>
		$heater_channels[[
			<tr>
				<td>$index</td>
				<td>
					<input type="text"
						id=$sf{'heater_%i_name', index0}
						value="$chc|get_channel_name{$index0}"
						disabled=true
					/>
				</td>
				<td>
					<input type="text"
						id="heater_${c}_resistance"
						value="$chc|get_resistance{$index0}"
					/>
				</td>
				<td>
					<input type="submit" value="Set"
						onclick="cryo_method('CryoHeaterConverter', 'set_channel_parameters', {
							'channel': parseInt(${c}),
							'name': $('heater_${c}_name').value,
							'resistance': parseInt($('heater_${c}_resistance').value)
						})"
						disabled=true
					/>
				</td>
			</tr>
		]]
		<!--
		<tr>
			<td colspan=2 style="background:#FFFF00;color:#000"><b>Supply Voltage:</b></td>
			<td>
				<input type="text" id="supply_voltage"
					value="${hc.config['supply_voltage']}"
				/>
			</td>
			<td>
				<input type="submit" value="Set"
					onclick="cryo_method('CryoHeaterConverter', 'set_parameters', {
						'supply_voltage': parseFloat($('supply_voltage').value)
					})"
				/>
			</td>
		</tr>
		-->
	</tbody>
</table>

</%doc>
