<%inherit file="globals.inc" />
<%doc>
// vim: ft=javascript
</%doc>
/* This function is intended to use with 'onkeypress' events, and filters
 * these events for "return" keys. Otherwise, it's just a dumb wrapper. */
function cryo_method_return(event, obj, method, args) {
	if (event && event.keyCode == 13)
		cryo_method(obj, method, args);
	else
		return true;
}

function cryo_method(obj, method, args, ajax_args) {
	ajax_args = typeof(ajax_args) == 'undefined' ? {} : ajax_args;

	$.ajax($.extend(ajax_args, {
		type: 'POST',
		url: '/methods/' + obj + '/' + method,
		data: JSON.stringify(args)
	}));
}

<%doc>
units_to_names = {
	${self.libcrython.RAW}		: { "name":"Raw", "unit":"" },
	${self.libcrython.HZ}		: { "name":"Hertz", "unit":"Hz" },
	${self.libcrython.VOLTS}	: { "name":"Volts", "unit":"V" },
	${self.libcrython.AMPS}		: { "name":"Amps", "unit":"A" },
	${self.libcrython.WATTS}	: { "name":"Watts", "unit":"W" },
	${self.libcrython.ADC_COUNTS}	: { "name":"ADC Counts", "unit":"" },
	${self.libcrython.DAC_COUNTS}	: { "name":"DAC Counts", "unit":"" },
	${self.libcrython.KELVIN}	: { "name":"Kelvin", "unit":"&deg;K" },
	${self.libcrython.OHMS}		: { "name":"Ohms", "unit":"&Omega;" },
};
</%doc>
waveforms_to_names = {
	${self.libcrython.SQUARE}	: "Square",
	${self.libcrython.DC}		: "DC",
	${self.libcrython.SINE}		: "AC",
};

names_to_waveforms = {
	"AC"	: ${self.libcrython.SINE},
	"DC"	: ${self.libcrython.DC},
};

function cryo_board_settings(func) {
	x = $.getJSON('/methods/CryoBoard/dump', func);
	return(x);
}

function format_si(f, u) {
	if(!u || u=="")
		u = "&nbsp;"

	if(typeof(f) == 'undefined' || f===false)
		return "";

	if (Math.abs(f)<1e-19)
		return "0.00&nbsp;&nbsp;" + u;
        else if(Math.abs(f)<1e-12)
	 	return (f*1e15).toFixed(2) + "&nbsp;f" + u;
        else if(Math.abs(f)<1e-9)
	 	return (f*1e12).toFixed(2) + "&nbsp;p" + u;
        else if(Math.abs(f)<1e-6)
	 	return (f*1e9).toFixed(2) + "&nbsp;n" + u;
        else if(Math.abs(f)<1e-3)
	 	return (f*1e6).toFixed(2) + "&nbsp;&mu;" + u;
        else if(Math.abs(f)<1)
	 	return (f*1e3).toFixed(2) + "&nbsp;m" + u;
        else if(Math.abs(f)<1e3)
	 	return (f).toFixed(2) + "&nbsp;&nbsp;" + u;
        else if(Math.abs(f)<1e6)
	 	return (f/1e3).toFixed(2) + "&nbsp;k" + u;
        else if(Math.abs(f)<1e9)
	 	return (f/1e6).toFixed(2) + "&nbsp;M" + u;
        else if(Math.abs(f)<1e12)
	 	return (f/1e9).toFixed(2) + "&nbsp;G" + u;
        else
	 	return f.toFixed(2) + "&nbsp;&nbsp;" + u;
}
